// Copyright 2000-2005 the Contributors, as shown in the revision logs.
// Licensed under the Apache Public Source License 2.0 ("the License").
// You may not use this file except in compliance with the License.

package org.ibex.crypto;


public class RC4 {
    private final byte[] s = new byte[256];
    private int x,y;
    
    public RC4(byte[] k) {
        for(int i=0;i<256;i++) s[i] = (byte)i;
        for(int i=0,j=0;i<256;i++) {
            j = (j + (s[i]&0xff) + (k[i%k.length]&0xff))&0xff;
            byte tmp = s[i];
            s[i] = s[j];
            s[j] = tmp;
        }
    }
    
    public void process(byte[] in, int ip, byte[] out, int op, int len) {
        int x = this.x;
        int y = this.y;
        byte[] s = this.s;
        for(int i=0;i<len;i++) {
            x = (x + 1) & 0xff;
            y = (y + (s[x]&0xff)) & 0xff;
            byte tmp = s[x];
            s[x] = s[y];
            s[y] = tmp;
            int t = ((s[x]&0xff) + (s[y]&0xff))&0xff;
            int k = s[t];
            out[op+i] = (byte)((in[ip+i]&0xff)^k);
        }
        this.x = x;
        this.y = y;
    }
}
